import React, { useMemo } from 'react';
import Context from './Context.ts';
import createStore from './createStore.ts';
export var substores = new Map();
var storeDispatchCovers = new WeakMap();
var Provider = function (_a) {
    var store = _a.store, name = _a.name, middlewares = _a.middlewares, reducer = _a.reducer, preloadedState = _a.preloadedState, _b = _a.dispatchBubbles, dispatchBubbles = _b === void 0 ? true : _b, children = _a.children;
    var value = useMemo(function () {
        // 当前模块卸载时, store不会重新创建, 从map缓存中取, 防止数据丢失
        var currentSubStore = substores.get(name);
        if (!currentSubStore) {
            var substore = createStore(reducer, preloadedState, middlewares);
            substores.set(name, substore);
            currentSubStore = substore;
        }
        var dispatch = currentSubStore.dispatch.bind(currentSubStore);
        // 防止当前模块内部store dispatch多次赋值, 避免多次调用父级的dispatch方法
        var hasCover = storeDispatchCovers.get(currentSubStore);
        if (!hasCover) {
            currentSubStore.dispatch = function (action) {
                storeDispatchCovers.set(currentSubStore, true);
                dispatch(action);
                if (dispatchBubbles) {
                    store.dispatch(action);
                }
                return action;
            };
        }
        return {
            name: name,
            store: currentSubStore,
            parentStore: store,
        };
    }, [store, reducer, preloadedState]);
    return (React.createElement(Context.Provider, { value: value }, children));
};
export default Provider;
//# sourceMappingURL=Provider.js.map