var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useContext, useReducer, } from 'react';
import hoistStatics from 'hoist-non-react-statics';
import Context from './Context.ts';
import { substores } from './Provider.tsx';
var initStateUpdates = function () { return [null, 0]; };
var storeStateUpdatesReducer = function (state, action) {
    var updateCount = state[1];
    return [action.payload, updateCount + 1];
};
var defaultMapDispatchToProps = function (dispatch) { return ({ dispatch: dispatch }); };
var defaultMapStateToProps = function () { return ({}); };
function connect(mapStateToProps, mapDispatchToProps) {
    var shouldHandleStateChanges = Boolean(mapStateToProps);
    if (!mapStateToProps) {
        mapStateToProps = defaultMapStateToProps;
    }
    if (!mapDispatchToProps) {
        mapDispatchToProps = defaultMapDispatchToProps;
    }
    return function WrappedWithConnect(WrappedComponent) {
        var wrappedComponentName = WrappedComponent.displayName
            || WrappedComponent.name || 'Component';
        var displayName = "connect" + wrappedComponentName;
        var Connect = function (props) {
            var _a;
            var _b = useContext(Context), store = _b.store, name = _b.name, parentStore = _b.parentStore;
            var state = __assign(__assign({}, parentStore.getState()), store.getState());
            var stateProps = mapStateToProps(state, props);
            var dispatchProps = mapDispatchToProps((_a = store) === null || _a === void 0 ? void 0 : _a.dispatch, props);
            // 分发dispatch时, 强制更新子组件
            var _c = useReducer(storeStateUpdatesReducer, null, initStateUpdates), forceComponentUpdateDispatch = _c[1];
            useEffect(function () {
                var _a;
                if (!shouldHandleStateChanges)
                    return;
                var forceUpdateFn = function () {
                    if (substores.get(name) !== store)
                        return;
                    forceComponentUpdateDispatch({
                        type: '@@redux/STORE_UPDATED',
                    });
                };
                var unsubscribe = (_a = store) === null || _a === void 0 ? void 0 : _a.subscribe(forceUpdateFn);
                return function () {
                    unsubscribe();
                };
            }, [store, parentStore]);
            return (React.createElement(WrappedComponent, __assign({}, props, stateProps, dispatchProps)));
        };
        Connect.WrappedComponent = WrappedComponent;
        Connect.displayName = displayName;
        return hoistStatics(Connect, WrappedComponent);
    };
}
export default connect;
//# sourceMappingURL=connect.js.map